数组中出现次数超过一半的数字

题目描述:

数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字。例如输入一个长度为9的数组{1,2,3,2,2,2,5,4,2}。由于数字2在数组中出现了5次,超过数组长度的一半,因此输出2。如果不存在则输出0。

分析:

简单题,思路就是用hashmap的键值对,存储数字和相应的出现次数。
注意特殊情况的判断。
出现超过一半的时候立即输出。后面还要遍历一遍键值对。

解答:

import java.util.HashMap;
public class Solution {
    public int MoreThanHalfNum_Solution(int [] array) {
        if(array==null || array.length==0)return 0;
        if (array.length == 1 || array.length==2) {
            return array[0];
        }
        int halflen = array.length /2;
        HashMap map = new HashMap<>();
        for (int i : array) {
            if (map.get(i) != null) {
                map.put(i, map.get(i) + 1);
                if (map.get(i) > halflen) {
                    return i;
                }
            }else{
                map.put(i, 1);
            }
        }
        return 0; //如果不存在,就输出0
        
    }
}
数组中出现次数超过一半的数字_第1张图片
运行结果

上述方法时间复杂度为:O(n^2)


进阶版:

解题思路

多数投票问题,可以利用 Boyer-Moore Majority Vote Algorithm(摩尔投票算法) 来解决这个问题,使得时间复杂度为 O(N)。

使用 cnt 来统计一个元素出现的次数,当遍历到的元素和统计元素不相等时,令 cnt--。如果前面查找了 i 个元素,且 cnt == 0 ,说明前 i 个元素没有 majority,或者有 majority,但是出现的次数少于 i / 2 ,因为如果多于 i / 2 的话 cnt 就一定不会为 0 。此时剩下的 n - i 个元素中,majority 的数目依然多于 (n - i) / 2,因此继续查找就能找出 majority。

代码:

public int MoreThanHalfNum_Solution(int[] nums) {
    int majority = nums[0];
    for (int i = 1, cnt = 1; i < nums.length; i++) {
        cnt = nums[i] == majority ? cnt + 1 : cnt - 1;
        if (cnt == 0) {
            majority = nums[i];
            cnt = 1;
        }
    }
    int cnt = 0;
    for (int val : nums)
        if (val == majority)
            cnt++;
    return cnt > nums.length / 2 ? majority : 0;
}

你可能感兴趣的:(数组中出现次数超过一半的数字)